---
title: MediaPositionState.position
slug: Web/API/MediaPositionState/position
tags:
  - API
  - Audio
  - Media
  - Media Session API
  - MediaPositionState
  - MediaSession API
  - Playback
  - Position
  - Property
  - Reference
  - Time
  - Video
---
<p>{{APIRef("Media Session API")}}</p>

<p><span class="seoSummary">The {{domxref("MediaPositionState")}} dictionary's <code><strong>position</strong></code> property is used when calling the {{domxref("MediaSession")}} method {{domxref("MediaSession.setPositionState", "setPositionState()")}} to provide the {{Glossary("user agent")}} with the current playback position, in seconds, of the currently-playing media.</span> This information is then, in turn, used by the user agent to provide a user interface which displays media playback information to the viewer.</p>

<p>For example, a browser might use this information along with the {{domxref("MediaPositionState.position", "position")}} property and the {{domxref("MediaSession.playbackState", "navigator.mediaSession.playbackState")}}, as well as the session's {{domxref("MediaSession.metadata", "metadata")}} to provide an integrated common user interface showing the currently playing media as well as standard pause, play, forward, reverse, and other controls.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">let <em>positionState</em> = { position: <em>timeInSeconds</em> };

let <em>duration</em> = <em>positionState</em>.duration;
</pre>

<h3 id="Value">Value</h3>

<p>A floating-point value indicating the current playback position within the media currently being performed, in seconds. This value should always be zero or more.</p>

<h2 id="Example">Example</h2>

<p>In this example, a player for a non-standard media file format, written in JavaScript, uses {{domxref("WindowOrWorkerGlobalScope.setInterval", "setInterval()")}} to establish a callback which fires once per second to refresh the position information by calling {{domxref("MediaSession.setPositionState", "setPositionState()")}}. If the media is still playing when the interval is fired, <code>setPositionState()</code> is called with an object that specifies the duration, playback rate, and position as reported by a <code>myMedia</code> object that describes the track being played.</p>

<p>If the media is not playing, {{domxref("WindowOrWorkerGlobalScope.clearInterval", "clearInterval()")}} is used to remove the interval handler.</p>

<pre>let positionInterval = window.setInterval(() =&gt; {
  if (myMedia.isPlaying) {
    navigator.mediaSession.setPositionState({
      duration: myMedia.trackDurationInSeconds,
      playbackRate: myMedia.playbackRate,
      position: myMedia.trackPlayPositionInSeconds
    });
  } else {
    window.clearInterval(positionInterval);
  }
}, 1000);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Media Session','#dom-mediapositionstate-position','MediaPositionState.position')}}</td>
   <td>{{Spec2('Media Session')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.MediaPositionState.position")}}</p>
